 rem Generated 1/25/2016 12:11:20 AM by Visual bB Version 1.0.0.548
 rem *************************************
 rem *Wal-Rush!                          *
 rem *A game of walrii, fish, and flight.*
 rem *Josiah Winslow                     *
 rem *josiah12301@yahoo.com              *
 rem *CC BY-NC-SA                        *
 rem *************************************

 rem Set size of ROM.
 set romsize 8k

 rem Initial settings.
 set tv ntsc
 set kernel_options player1colors

 rem Variable aliases.
 dim sc1=score
 dim sc2=score+1
 dim sc3=score+2
 dim P0_X=player0x.a
 dim P1_X=player1x.b
 dim bmp_48x2_2_index=c
 dim _Walrii_Y_Vel=d
 dim _Bit_Op_All_Purpose=e
 dim _Bit0_Fire_Restrainer=e
 dim _Bit1_Walrii_Flying=e
 dim _Bit2_Reset_Restrainer=e
 dim _Bit3_Game_Over=e
 dim _Bit4_Switch_Scores=e
 dim _Structure_Timer=f
 dim _Structure_Identifier=g
 dim _Fish_Animation=h
 dim _Fish_Animation_Delay=i
 dim _Scroll_Timer=j
 dim _Slow_Score_Increment=k
 dim hi_sc1=l
 dim hi_sc2=m
 dim hi_sc3=n
 dim temp_sc1=o
 dim temp_sc2=p
 dim temp_sc3=q
 dim _Master_Counter=r
 dim _Frame_Counter=s

 rem Place to jump to after a reset or new game.
_Start_Restart

 rem Clear all bit variables except Game_Over (to start properly).
 _Bit_Op_All_Purpose=_Bit_Op_All_Purpose&%00001000

 rem Clear score.
 score=0

 rem Jump to main game loop if resetting from Game Over.
 if _Bit3_Game_Over{3} then goto _Main_Game_Loop_Setup

 rem Set up the title screen.
_Title_Screen_Setup

 rem Set animation timer to 0.
 _Frame_Counter=0

 rem Give the score a nice shade-y grey effect for the title screen.
 const scorefade=1
 scorecolor=$08

 rem Makes it so you can't skip the title screen by holding RESET or FIRE before it shows up.
 _Bit0_Fire_Restrainer{0}=1
 _Bit2_Reset_Restrainer{2}=1

 rem Title screen (made with Titlescreen Kernel).
_Title_Screen

 rem Draw the title screen.
 gosub titledrawscreen bank2

 rem Loop through the title screen's animation (the walrus is flying!).
 _Frame_Counter=_Frame_Counter+1:temp1=_Frame_Counter&%00001111
 if temp1=0 then bmp_48x2_2_index=bmp_48x2_2_index+48
 if bmp_48x2_2_index=96 then bmp_48x2_2_index=0

 rem Loops title screen until RESET or FIRE is pressed.
 if !switchreset && !joy0fire then _Bit0_Fire_Restrainer{0}=0:_Bit2_Reset_Restrainer{2}=0:goto _Title_Screen
 if _Bit0_Fire_Restrainer{0} then goto _Title_Screen
 if _Bit2_Reset_Restrainer{2} then goto _Title_Screen

 rem Setup for game start.
_Main_Game_Loop_Setup

 rem Graphics data.
 playfield:
 ................................
 ................................
 ................................
 ................................
 ..X...X...X...X...X...X...X...X.
 .X.X.X.X.X.X.X.X.X.X.X.X.X.X.X.X
 X...X...X...X...X...X...X...X...
 .X.X.X.X.X.X.X.X.X.X.X.X.X.X.X.X
 ..X...X...X...X...X...X...X...X.
 .X.X.X.X.X.X.X.X.X.X.X.X.X.X.X.X
 X...X...X...X...X...X...X...X...
end

 player1color:
 $04
 $04
 $04
 $04
 $04
 $04
 $04
 $04
 $04
 $04
 $04
 $04
 $80
 $80
 $80
 $80
 $04
 $04
end

 player1:
 %10110110
 %10110110
 %11111111
 %11111111
 %10101111
 %10101111
 %10101111
 %10101111
 %10101111
 %10101111
 %11111111
 %11111111
 %11011010
 %11011010
 %10010010
 %10010010
 %01101100
 %01101100
end

 rem Sets game to be NOT over.
 _Bit3_Game_Over{3}=0

 rem Initialize variables for game.
 COLUPF=$08
 COLUBK=$0E
 COLUP0=$00
 scorecolor=$00
 score=0
 player0x=255:player0y=255
 _Bit1_Walrii_Flying{1}=0
 _Structure_Timer=240
 _Structure_Identifier=0
 _Fish_Animation=0
 _Fish_Animation_Delay=0
 _Scroll_Timer=0
 _Slow_Score_Increment=0

 rem We can't have the game start right away! The player needs a chance to press FIRE to start their maiden voyage.

 rem Initialize variables for starting animation.
 _Frame_Counter=21
 player1x=128:player1y=56
 _Bit0_Fire_Restrainer{0}=1
 _Bit2_Reset_Restrainer{2}=1

 rem Place to wait until FIRE is pressed.
_Wait_For_Fire

 rem Make the Walrii twice as wide.
 NUSIZ1=$05

 rem Draw the screen.
 drawscreen

 rem Animate the scrolling playfield and flying Walrii.
 _Frame_Counter=_Frame_Counter+1
 if _Frame_Counter=22 then player1y=56
 if _Frame_Counter=44 then _Frame_Counter=0:player1y=54
 if _Scroll_Timer=10 then _Scroll_Timer=0:pfscroll right
 _Scroll_Timer=_Scroll_Timer+1

 rem Reset game entirely if RESET is pressed.
 if !switchreset then _Bit2_Reset_Restrainer{2}=0:goto _Skip_Reset_Check_1
 if _Bit2_Reset_Restrainer{2} then goto _Skip_Reset_Check_1

 rem RESET button pressed, re-start game entirely.
 goto _Start_Restart

 rem RESET button not pressed, continue.
_Skip_Reset_Check_1

 rem Wait until FIRE is pressed.
 if !joy0fire then _Bit0_Fire_Restrainer{0}=0:goto _Wait_For_Fire
 if _Bit0_Fire_Restrainer{0} then goto _Wait_For_Fire
 _Bit0_Fire_Restrainer{0}=1

 rem Initialize counter for frame delay between Walrii movements (he moves FAST).
 _Frame_Counter=3

 rem Give the Walrii a kick-start upwards.
 _Walrii_Y_Vel=-6

 rem Main game loop.
_Main_Game_Loop

 rem Draw the screen.
 drawscreen

 rem Make Walrii twice as wide.
 NUSIZ1=$05

 rem Scroll the screen on a timer.
 if _Scroll_Timer=10 then _Scroll_Timer=0:pfscroll right
 _Scroll_Timer=_Scroll_Timer+1

 rem Random structure generator.
 if _Structure_Timer=240 then _Structure_Timer=0:player0x=0:player0y=(rand&63)+21:gosub _Generate_Structure
 if _Structure_Identifier=0 then NUSIZ0=$05:goto _Mine
 if _Structure_Identifier=1 then goto _Fish
 if _Structure_Timer>0 then goto _Skip_Structures

 rem Mine (spikey ball).
_Mine

 player0:
 %10010001
 %10010001
 %01001010
 %01001010
 %00111100
 %00111100
 %01111101
 %01111101
 %10111110
 %10111110
 %00111100
 %00111100
 %01010010
 %01010010
 %10001001
 %10001001
end

 goto _Skip_Structures

 rem Fish (collectible item).
_Fish

 rem Choose animation frame.
 if _Fish_Animation=0 then goto _Fish_0
 if _Fish_Animation=1 then goto _Fish_1
 if _Fish_Animation=2 then goto _Fish_2
 if _Fish_Animation=3 then goto _Fish_1

_Fish_0
 player0:
 %11011000
 %10101000
 %10000110
 %01000010
 %01000001
 %01000101
 %00110001
 %00001110
end
 goto _Skip_Fish_Frames

_Fish_1
 player0:
 %00000000
 %11011110
 %10100001
 %01000001
 %10100101
 %11010010
 %00001100
 %00000000
end
 goto _Skip_Fish_Frames

_Fish_2
 player0:
 %00001110
 %00110001
 %01000101
 %01000001
 %01000010
 %10000110
 %10101000
 %11011000
end

_Skip_Fish_Frames

 rem Change fish animation frame.
 if _Fish_Animation_Delay=0 then _Fish_Animation_Delay=8:_Fish_Animation=_Fish_Animation+1
 _Fish_Animation_Delay=_Fish_Animation_Delay-1
 if _Fish_Animation=4 then _Fish_Animation=0

_Skip_Structures

 rem Move structure based on timer.
 _Structure_Timer=_Structure_Timer+1:P0_X=P0_X+0.6

 rem Frame delay for Walrii.
 _Frame_Counter=_Frame_Counter-1
 if _Frame_Counter>0 then goto _Skip_Walrii_Move
 if _Frame_Counter=0 then _Frame_Counter=3

 rem "Repetition Restrainer".
 if !joy0fire then _Bit0_Fire_Restrainer{0}=0:goto _Skip_RR
 if _Bit0_Fire_Restrainer{0} then goto _Skip_RR
 _Bit0_Fire_Restrainer{0}=1:_Bit1_Walrii_Flying{1}=1

_Skip_RR

 rem Check if Walrii should be flying.
 if !_Bit1_Walrii_Flying{1} then _Walrii_Y_Vel=_Walrii_Y_Vel+1:goto _Skip_Fly

 rem Change Walrii Y velocity.
 _Walrii_Y_Vel=-6:_Bit1_Walrii_Flying{1}=0

_Skip_Fly

 rem Add Y velocity to position.
 player1y=player1y+_Walrii_Y_Vel

 rem Change X position based on keypress.
 if joy0left then P1_X=P1_X-2.5
 if joy0right then P1_X=P1_X+2.5

_Skip_Walrii_Move

 rem Adjust Y position so you don't wrap around the screen.
 if player1y<18 then player1y=18

 rem Adjust X position so you don't wrap around the screen.
 if player1x<16 then player1x=16
 if player1x>128 then player1x=128

 rem Despawn mine and trigger game over if a mine has been hit.
 if _Structure_Identifier=0 && collision(player1,player0) then player0y=255:_Bit3_Game_Over{3}=1

 rem Despawn fish if a fish has been collected.
 if _Structure_Identifier=1 && collision(player1,player0) then player0y=255 else goto _Skip_Fish

 rem Add 10 to your score if a fish has been collected and the score won't overflow.
 if sc1=$99 && sc2=$99 && sc3>$89 then score=999999:goto _Skip_Add_10_Points
 score=score+10
_Skip_Add_10_Points

 rem Respawn the next obstacle early if a fish has been collected.
 if _Structure_Timer<200 then _Structure_Timer=200

_Skip_Fish

 rem Add 1 to your score if you have flew for long enough and the score won't overflow.
 _Slow_Score_Increment=_Slow_Score_Increment+1
 if _Slow_Score_Increment=200 then _Slow_Score_Increment=0 else goto _Skip_Add_1_Point
 if sc1=$99 && sc2=$99 && sc3=$99 then goto _Skip_Add_1_Point
 score=score+1
_Skip_Add_1_Point

 rem If Walrii falls off the screen, then the game is over.
 if player1y>107 then _Bit3_Game_Over{3}=1

 rem Set up Game Over screen if game is over.
 if _Bit3_Game_Over{3} then goto _Game_Over_Setup

 rem Re-start game entirely if RESET is pressed.
 if !switchreset then _Bit2_Reset_Restrainer{2}=0:goto _Main_Game_Loop
 if _Bit2_Reset_Restrainer{2} then goto _Main_Game_Loop
 goto _Start_Restart

 rem Set up the Game Over routine.
_Game_Over_Setup

 rem Check if high score should be updated.
 if sc1>hi_sc1 then goto _New_High_Score
 if sc2>hi_sc2 then goto _New_High_Score
 if sc3>hi_sc3 then goto _New_High_Score
 goto _Skip_High_Score

_New_High_Score

 rem Update high score.
 hi_sc1=sc1:hi_sc2=sc2:hi_sc3=sc3

_Skip_High_Score

 rem Store score in temporary place, so we can flip between it and the high score.
 temp_sc1=sc1:temp_sc2=sc2:temp_sc3=sc3

 rem Hide the current obstacle.
 player0y=255

 rem If Walrii is offscreen, put him onscreen for a brief moment.
 if player1y>107 then player1y=88

 rem Change Walrii to an explosion sprite, for an animation sort of thing.
 player1color:
 $1E
 $1E
 $1E
 $1E
 $1E
 $1E
 $1E
 $1E
 $1E
 $1E
 $1E
 $1E
 $1E
 $1E
 $1E
 $1E
 $1E
 $1E
 $1E
 $1E
end

 player1:
 %0000010
 %0000010
 %0001000
 %0001000
 %0010000
 %0010000
 %1000000
 %1000000
 %0001000
 %0001000
 %0100001
 %0100001
 %1000100
 %1000100
 %0010000
 %0010000
 %0000100
 %0000100
 %0001000
 %0001000
end

 rem Make background red.
 COLUBK=$40

 rem Initialize frame counters.
 _Master_Counter=72
 _Frame_Counter=0

 rem Give a little explosion animation.
_Game_Over_Anim

 rem Make the Walrii twice as wide.
 NUSIZ1=$05

 rem Flips the Walrii graphic every 4 frames.
 _Frame_Counter=_Frame_Counter+1
 if _Frame_Counter=8 then _Frame_Counter=0
 if _Frame_Counter<4 then REFP1=8

 rem Draw the screen.
 drawscreen

 rem Loop the "animation" until it's over.
 _Master_Counter=_Master_Counter-1
 if _Master_Counter>0 then goto _Game_Over_Anim

 rem Put background back to normal.
 COLUBK=$0E

 rem Hide Walrii.
 player1y=255

 rem Initialize frame counters.
 _Master_Counter=0
 _Frame_Counter=0

 rem Game Over screen.
_Game_Over_Loop

 rem The Master Counter counts up to 2 seconds. After 2 seconds, you may press the RESET or FIRE button.
 _Master_Counter=_Master_Counter+1
 if _Master_Counter<120 then goto _Skip_120_Counter

 rem After 2 seconds, switch the displayed score to your highscore.
 _Master_Counter=0:_Bit4_Switch_Scores{4}=!_Bit4_Switch_Scores{4}
 if _Bit4_Switch_Scores{4} then scorecolor=$C0:sc1=hi_sc1:sc2=hi_sc2:sc3=hi_sc3:goto _Skip_Flip
 scorecolor=$00:sc1=temp_sc1:sc2=temp_sc2:sc3=temp_sc3

_Skip_Flip

 rem The Frame Counter counts up to 20 seconds. After 20 seconds, the game auto-resets.
 _Frame_Counter=_Frame_Counter+1
 if _Frame_Counter=10 then _Bit3_Game_Over{3}=0:goto _Start_Restart

_Skip_120_Counter

 rem Draw the screen.
 drawscreen

 rem Loops Game Over screen for 2 seconds, before you are allowed to reset.
 if _Frame_Counter=0 then goto _Game_Over_Loop

 rem Loops Game Over screen until RESET or FIRE is pressed.
 if !switchreset && !joy0fire then _Bit2_Reset_Restrainer{2}=0:goto _Game_Over_Loop
 if _Bit0_Fire_Restrainer{0} then goto _Game_Over_Loop
 goto _Start_Restart

 rem Structure generator subroutine.
_Generate_Structure
 if rand>140 then _Structure_Identifier=0 else _Structure_Identifier=1
 return

 rem ROM Bank with titlescreen graphics data (included in the "titlescreen" files).
 bank 2
 asm
 include "titlescreen/asm/titlescreen.asm"
end